window.fetal = {};

(function($, window, undefined) {
    $.danidemo = $.extend({}, {

        addLog: function(id, status, str) {
            var d = new Date();
            var li = $('<li />', { 'class': 'demo-' + status });

            var message = '[' + d.getHours() + ':' + d.getMinutes() + ':' + d.getSeconds() + '] ';

            message += str;

            li.html(message);

            $(id).prepend(li);
        },

        addFile: function(id, i, file) {
            var progress_color = 'line-green';

            // window.netError = false;
            window.fetal[i] = {};
            window.fetal[i].file = file;
            window.fetal[i].percent = 0;
            window.fetal[i].status = 'wait';
            //console.log(window.fetal)

            var template = '<div id="demo-file' + i + '" index="' + i + '">' +
                '<div class="demo-file-detail ' + progress_color + '">' +
                '<span class="demo-file-id">' + file.name + '</span> <span class="demo-file-size">' + $.danidemo.humanizeSize(file.size) + '</span> <span class="demo-file-status"><img id="img-again" style="display:none;cursor:pointer" width="14px" height="14px" src="img/again.png" />' +
                '<img id="img-wrong" width="14px" height="14px" style="cursor:pointer" src="img/wrong.png" />' +
                '<img id="img-right" width="14px" height="14px" style="display:none"  src="img/right.png" />' +
                '</span>' +
                '</div>' +
                '<div class="progress progress-striped active">' +
                '<div class="progress-bar line-green" role="progressbar" style="width: 0%;">' +
                '<span class="sr-only">0% Complete</span>' +
                '</div>' +
                '</div>' +
                '</div>';

            var i = $(id).attr('file-counter');
            if (!i) {
                $(id).empty();

                i = 0;
            }

            i++;

            $(id).attr('file-counter', i);

            $(id).append(template);
        },

        updateFileStatus: function(i, status, message) {
            var src;
            switch (status) {
                case 'success':
                    src = 'img-right';
                    break;
                case 'default':
                    src = 'img-wrong';
                    break;
            }
            $('#demo-file' + i).find('span.demo-file-status').find('img').css("display", "none");
            $('#demo-file' + i).find('span.demo-file-status').find('#' + src).css("display", "");
        },

        updateFileProgress: function(i, percent) {
            $('#demo-file' + i).find('div.progress-bar').width(percent);

            $('#demo-file' + i).find('span.sr-only').html(percent + ' Complete');
        },

        updateNetError: function(i) {
            $('#demo-file' + i).find('div.progress-bar').addClass('line-red');
            $('#demo-file' + i).find('span.demo-file-status').find('img').css("display", "none");
            $('#demo-file' + i).find('span.demo-file-status').find('#img-again').css("display", "");
        },

        humanizeSize: function(size) {
            var i = Math.floor(Math.log(size) / Math.log(1024));
            return (size / Math.pow(1024, i)).toFixed(2) * 1 + ' ' + ['B', 'kB', 'MB', 'GB', 'TB'][i];
        }

    }, $.danidemo);


    $.reupload = $.extend({}, {
        waiter: [],
        inProgress: false,
        init: function(data) {

            this.url = data.url;
            this.method = data.method;

            if (!this.inProgress) {
                this.index = data.id;
                this.resetProgress();
                this.ajax();
            } else {
                this.waiter.push(data.id);
            }

            $.danidemo.updateFileStatus(data.id, 'default', '正在上传...');
        },
        resetProgress: function() {

            $('#demo-file' + this.index).find('div.progress-bar').removeClass('line-red');
            //$.danidemo.updateFileProgress(this.index, '0%');
        },
        ajax: function() {
            // Form Data
            var fd = new FormData();
            fd.append(window.fetal[this.index].file.name, window.fetal[this.index].file);
            var that = this;
            // Ajax Submit
            $.ajax({
                url: this.url,
                type: this.method,
                dataType: 'json',
                //timeout : 1000,
                data: fd,
                cache: false,
                contentType: false,
                processData: false,
                forceSync: false,
                xhr: function() {
                    var xhrobj = $.ajaxSettings.xhr();
                    if (xhrobj.upload) {
                        xhrobj.upload.addEventListener('progress', function(event) {
                            try {
                                that.inProgress = true;
                                var percent = 0;
                                var position = event.loaded || event.position;
                                var total = event.total || e.totalSize;
                                if (event.lengthComputable) {
                                    percent = Math.ceil(position / total * 100);
                                }

                                window.fetal[that.index].status = 'progress';

                                var percentStr = percent + '%';
                                console.log(percentStr)

                                if (percent >= window.fetal[that.index].percent) {
                                    window.fetal[that.index].percent = percent;
                                    $.danidemo.updateFileProgress(that.index, percentStr);
                                }
                            } catch (e) {};
                        }, false);

                        xhrobj.upload.addEventListener('error', function(event) {
                            console.log('error')
                            that.inProgress = false;
                            that.waiter = [];
                            that.onNetError(that.index);
                        }, false);

                        xhrobj.upload.addEventListener('timeout', function(event) {
                            console.log('timeout')
                            that.inProgress = false;
                            that.waiter = [];

                            that.onNetError(that.index);
                        }, false);
                    }

                    return xhrobj;
                },
                success: function(data, message, xhr) {
                    console.log('xhrsuccess')
                    that.inProgress = false;
                    that.onUploadSuccess(that.index);

                    var pos = that.waiter.indexOf(that.index);
                    if (pos >= 0) that.waiter.splice(pos, 1);

                    if (that.waiter.length > 0) {
                        that.index = that.waiter[0];
                        that.resetProgress();
                        that.ajax();
                    }
                    // console.log('success'+that.index)
                },
                error: function(xhr, status, errMsg) {

                    console.log('xhrerror')
                    that.inProgress = false;
                    that.waiter = [];
                    that.onUploadError(that.index, errMsg);
                },
                complete: function(xhr, textStatus) {
                    console.log('xhrcomplete')
                }
            });
        },
        onUploadSuccess: function(id, message) {
            $.danidemo.updateFileStatus(id, 'success', '上传成功');
            $('#demo-file' + id).find('.demo-file-detail').removeClass('line-green');
            $.danidemo.updateFileProgress(id, '0%');
        },
        onUploadError: function(id, message) {
            $.danidemo.updateFileStatus(this.index, 'error', message);
            $.danidemo.updateNetError(this.index);
        },
        onNetError: function() {
            $.danidemo.updateNetError(this.index);
        },
        removeUpload: function(index) {
            if (!this.waiter.length) return true;
            else {
                var pos = this.waiter.indexOf(index);
                if (this.waiter.indexOf(index) >= 0) {
                    this.waiter.splice(pos, 1);
                    return false;
                }
            }
            return true;

        },
        deleteHttpRequest: function(index, status) {
            // console.log(index+'delete')

            $.ajax({
                type: 'POST',
                url: 'delete',
                data: {
                    path: encodeURI(window.fetal[index].file.name)
                },
                success: function() {
                    //console.log('delete success');
                    if (status)
                        $.reupload.init({
                            id: index,
                            url: 'upload',
                            method: 'post'
                        });

                },
                error: function() {
                    //console.log('delete fail');
                },
                dataType: 'json',
            });
        }
    }, $.reupload);

})(jQuery, this);